<script setup lang="ts">
import { useOrderReceiptStore } from '@/stores/orderReceipt';
import { useStockStore } from '@/stores/stock';
import type { OrderReceipt } from '@/types/OrderReceipt';
import type { Stock } from '@/types/Stock';
import { computed, nextTick, ref } from 'vue';
import { onMounted } from 'vue';
import type { VForm } from 'vuetify/components';

const stockStore = useStockStore()
const OrderReceiptStore = useOrderReceiptStore()
const headers = [
    {
        title: 'Id',
        key: 'id',
        value: 'id'
    },
    {
        title: 'Receipt Date',
        key: 'receiptDate',
        value: 'receiptDate'
    },
    {
        title: 'Total Qty',
        key: 'totalQty',
        value: 'totalQty'
    },
    {
        title: 'Total Price',
        key: 'totalPrice',
        value: (item: OrderReceipt) => item.totalPrice.toFixed(2)
    },
    {
        title: 'EMP ID',
        key: 'employeeId',
        value: 'employeeId'
    },
    {
        title: 'EMP Name',
        key: 'employeeName',
        value: 'employeeName'
    },
    { title: '', key: 'actions', sortable: false }
]


const search = ref('')
const dialog = ref(false)
const refForm = ref<VForm | null>(null)
const form = ref(false)
const loading = ref(false)
const divOrderReceiptItems = ref<HTMLElement | null>(null)
const dialogShowOrderReceiptItems = ref(false)


const filteredOrderStock = computed(() => {
    const searchValue = search.value;
    return OrderReceiptStore.orderReceiptsData.filter(orderReceipt => {
        const formattedDate = formatDate(orderReceipt.receiptDate);
        return formattedDate.includes(searchValue);
    });
});

function onSubmit() { }

function closeDialog() {
    dialog.value = false
    dialogShowOrderReceiptItems.value = false
    nextTick(() => {
        OrderReceiptStore.clearOrderReceipt()
        OrderReceiptStore.clearReceiptItems()
    })
}

async function addReceiptItems(s: Stock) {
    const { valid } = await refForm.value!.validate()
    OrderReceiptStore.addReceiptItems(s)
    if (!valid) return
    nextTick(() => {
        if (divOrderReceiptItems.value) divOrderReceiptItems.value.scrollTo(0, divOrderReceiptItems.value.scrollHeight)
    })
}

async function showOrderReceiptDialog(item: OrderReceipt) {
    if (!item.id) return
    await OrderReceiptStore.getOrderReceipt(item.id)
    dialogShowOrderReceiptItems.value = true
}

async function save() {
    const { valid } = await refForm.value!.validate()
    if (!valid) return
    if (OrderReceiptStore.orderReceiptItems.length === 0) return

    OrderReceiptStore.saveOrderReceipt()
    closeDialog()
}

function formatDate(date: Date) {
    const formattedDate = new Date(date).toLocaleDateString('en-GB', {
        day: '2-digit',
        month: '2-digit',
        year: 'numeric'
    });
    return formattedDate
}

onMounted(async () => {
    await stockStore.getStocks()
    await OrderReceiptStore.getOrderReceipts()
})
</script>

<template>
    <div style="width: 95%;height: 100%;">
        <v-card-title class="d-flex align-center pe-2">
            <v-spacer></v-spacer>
        </v-card-title>
        <v-data-table :headers="headers" :items="filteredOrderStock">
            <template v-slot:[`item.receiptDate`]="{ value }">
                {{ formatDate(value) }}
            </template>
            <template v-slot:top>
                <v-toolbar flat color="#F48FB1">
                    <v-toolbar-title>
                        <v-icon icon="mdi-truck-delivery">
                        </v-icon>Stock Receipt</v-toolbar-title>
                    <v-divider class="mx-4" inset vertical></v-divider>
                    <v-spacer></v-spacer>
                    <!--orderReceipt Dialog-->
                    <v-dialog v-model="dialog" persistent width="1440" height="800">
                        <template v-slot:activator="{ props }">
                            <v-btn color="#ECEFF1" variant="flat" v-bind="props">
                                <v-icon icon="mdi-plus">
                                </v-icon>
                                New Stock Receipt
                            </v-btn>
                        </template>
                        <v-card>
                            <v-card-title>
                                <span class="text-h5">Receipt Items</span>
                            </v-card-title>
                            <v-card-text>
                                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                                    <v-container>
                                        <v-row>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-select v-model="OrderReceiptStore.editedOrderReceiptItem.stock"
                                                    label="Please Select Stock" :items="stockStore.stocks"
                                                    item-title="name" return-object>
                                                </v-select>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field type="number"
                                                    v-model.number="OrderReceiptStore.editedOrderReceiptItem.qty"
                                                    :readonly="loading" :rules="[(v) => v >= 0]" class="mb-2" clearable
                                                    label="QTY" placeholder="Enter your QTY"></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field type="number"
                                                    v-model.number="OrderReceiptStore.editedOrderReceiptItem.price"
                                                    :readonly="loading" :rules="[(v) => v >= 0]" class="mb-2" clearable
                                                    label="Price" placeholder="Enter your Price"></v-text-field>
                                            </v-col>
                                        </v-row>
                                    </v-container>
                                    <v-card-actions aria-label="right">
                                        <v-btn color="green" variant="flat"
                                            @click="addReceiptItems(OrderReceiptStore.editedOrderReceiptItem.stock!)">ADD</v-btn>
                                        <v-btn color="red" variant="flat"
                                            @click="OrderReceiptStore.clearReceiptItems()">Cancel</v-btn>
                                    </v-card-actions>
                                </v-form>
                                <small>*indicates required field</small>

                                <div ref="divOrderReceiptItems" style="height: 400;overflow: auto;">
                                    <v-sheet min-width="400" max-width="1340" height="400" elevation="4">
                                        <v-table>
                                            <template v-slot:default>
                                                <thead>
                                                    <tr>
                                                        <th>#</th>
                                                        <th>name</th>
                                                        <th>qty</th>
                                                        <th>price</th>
                                                        <th>total</th>
                                                        <th></th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    <tr v-for="(item, index) of OrderReceiptStore.orderReceiptItems"
                                                        :key="item.id">
                                                        <td>{{ index + 1 }}</td>
                                                        <td>{{ item.name }}</td>
                                                        <td>{{ item.qty }}</td>
                                                        <td>{{ item.price }}</td>
                                                        <td>{{ item.price * item.qty }}</td>
                                                        <td><v-btn icon="mdi-delete" density="compact"
                                                                @click="() => { OrderReceiptStore.removeOrderReceiptItems(item) }"></v-btn>
                                                        </td>
                                                    </tr>
                                                </tbody>
                                            </template>
                                        </v-table>
                                    </v-sheet>
                                </div>
                            </v-card-text>

                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="red" variant="flat" @click="closeDialog">
                                    Close
                                </v-btn>
                                <v-btn color="green" variant="flat" @click="save">
                                    Save
                                </v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                    <v-divider class="mx-4" inset vertical></v-divider>
                    <v-text-field class="mx-2" v-model="search" prepend-inner-icon="mdi-magnify" density="compact"
                        label="Search" single-line flat hide-details variant="outlined"></v-text-field>
                    <!-- showOrderReceiptItems -->
                    <v-dialog v-model="dialogShowOrderReceiptItems" width="520" height="800" persistent>
                        <v-card>
                            <v-card-title class="text-h5">OrderReceipt Item</v-card-title>
                            <div style="margin: 10px;">
                                <v-spacer></v-spacer>
                                <td>วันที่สั่งสินค้า: {{
            formatDate(OrderReceiptStore.editedOrderReceipt.receiptDate) }}
                                </td>
                                <v-spacer></v-spacer>
                                <td>ผู้ซื้อสินค้า: {{ OrderReceiptStore.editedOrderReceipt.employeeName }}</td>
                                <v-spacer></v-spacer>
                                <v-card-text>
                                    <v-table>
                                        <template v-slot:default>
                                            <thead>
                                                <tr>
                                                    <th>#</th>
                                                    <th>name</th>
                                                    <th>qty</th>
                                                    <th>price</th>
                                                    <th>total</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <tr v-for="(item, index) of OrderReceiptStore.editedOrderReceipt.orderReceiptItem!"
                                                    :key="item.id">
                                                    <td>{{ index + 1 }}</td>
                                                    <td>{{ item.name }}</td>
                                                    <td>{{ item.qty }}</td>
                                                    <td>{{ item.price.toFixed(2) }}</td>
                                                    <td>{{ item.total.toFixed(2) }}</td>
                                                </tr>
                                            </tbody>
                                        </template>
                                    </v-table>
                                    <td>จำนวนสินค้าทั้งหมด:{{ OrderReceiptStore.editedOrderReceipt.totalQty }} Unit</td>
                                    <v-spacer></v-spacer>
                                    <td>ยอดเงินรวม:{{ OrderReceiptStore.editedOrderReceipt.totalPrice.toFixed(2) }} Baht
                                    </td>
                                </v-card-text>
                            </div>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="red" variant="flat" @click="closeDialog">
                                    Close
                                </v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </v-toolbar>
            </template>
            <template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" class="me-2" @click="showOrderReceiptDialog(item)"> mdi-receipt-text</v-icon>
            </template>
        </v-data-table>
    </div>
</template>
